#
# Conditional build:
%bcond_without	ocaml_opt	# skip building native optimized binaries (bytecode is always built)

# not yet available on x32 (ocaml 4.02.1), remove when upstream will support it
%ifnarch %{ix86} %{x8664} arm aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

%define debug_package %{nil}
%define	pkgname	curl
Summary:	OCaml Curl library (ocurl)
Name:		ocaml-%{pkgname}
Version:	0.9.1
Release:	2
License:	MIT
Group:		Libraries
Source0:	https://github.com/ygrek/ocurl/releases/download/%{version}/ocurl-%{version}.tar.gz
# Source0-md5:	1ff6b12803fa0c6e9a4358dd29b83910
Patch0:		ocaml_opt.patch
URL:		http://ocurl.forge.ocamlcore.org/
BuildRequires:	curl-devel >= 7.12.0
BuildRequires:	gawk
BuildRequires:	ocaml >= 3.10.0-7
BuildRequires:	ocaml-findlib-devel
# Explicitly require Curl (fixes RHBZ#711261). Since ocaml-curl uses
# -custom rather than ocamlmklib, automatic detection is infeasible.
Requires:	curl-devel >= 7.12.0
%requires_eq	ocaml-runtime
ExcludeArch:	sparc64 s390 s390x
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Ocaml Curl Library (Ocurl) is an interface library for the
programming language Ocaml to the networking library libcurl.

%package devel
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n ocurl-%{version}
%patch0 -p1

%build
%configure
%{__make} -j1 all

%install
rm -rf $RPM_BUILD_ROOT
export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml
install -d $OCAMLFIND_DESTDIR $OCAMLFIND_DESTDIR/stublibs

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# Install curl.mli
cp -p curl.mli $OCAMLFIND_DESTDIR/curl

cat > $RPM_BUILD_ROOT%{_libdir}/ocaml/curl/META <<EOF
requires = ""
version = "%{version}"
directory = "+curl"
archive(byte) = "curl.cma"
archive(native) = "curl.cmxa"
linkopts = ""
EOF

# Make clean in the examples dir so our docs don't contain binaries.
%{__make} -C examples clean

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc COPYING
%dir %{_libdir}/ocaml/curl
%{_libdir}/ocaml/curl/META
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllcurl-helper.so
%{_libdir}/ocaml/stublibs/dllcurl-helper.so.owner
%{_libdir}/ocaml/curl/*.cma
%if %{with ocaml_opt}
%attr(755,root,root) %{_libdir}/ocaml/curl/*.cmxs
%endif

%files devel
%defattr(644,root,root,755)
%doc examples/*
%{_libdir}/ocaml/curl/*.a
%{_libdir}/ocaml/curl/*.cmi
%{_libdir}/ocaml/curl/*.cmt
%{_libdir}/ocaml/curl/*.cmti
%if %{with ocaml_opt}
%{_libdir}/ocaml/curl/*.cmx
%{_libdir}/ocaml/curl/*.cmxa
%endif
%{_libdir}/ocaml/curl/*.mli
%changelog
* Sat Mar 27 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-curl.git;a=log;h=master

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> 90c843a
- fix non-opt files

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> a1673ef
- cleanup files
- rel 2

* Wed Mar 24 2021 Jan Rękorajski <baggins@pld-linux.org> 9ed0416
- updated opt patch
- install META where dune expects it

* Wed Mar 24 2021 Jan Rękorajski <baggins@pld-linux.org> e88cf73
- up to 0.9.1

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> 10d7111
- rebuild with ocaml 4.04.1
- release 5 (by relup.sh)

* Fri Mar 18 2016 Jan Rękorajski <baggins@pld-linux.org> a53b4f3
- release 4 (by relup.sh)

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> a82d6b2
- release 3 (by relup.sh)

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> 5750614
- cleaned up ocaml_opt bcond usage

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> 9781d07
- fix install without ocaml opt build

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> c63f57e
- strict ocaml deps
- rel 2

* Sat Aug 30 2014 Jan Rękorajski <baggins@pld-linux.org> 8fd8b94
- up to 0.7.1

* Mon Feb 17 2014 Jan Rękorajski <baggins@pld-linux.org> d878cf6
- fix source url and md5sum

* Mon Feb 17 2014 Jan Rękorajski <baggins@pld-linux.org> ec5b7a8
- up to 0.6.1

* Sun Nov 24 2013 Elan Ruusamäe <glen@delfi.ee> 4790749
- package site meta for ocamlfind to work

* Sat Nov 23 2013 Elan Ruusamäe <glen@delfi.ee> f6f0b5d
- rename to curl to match module name

* Sat Nov 23 2013 Elan Ruusamäe <glen@delfi.ee> 56573ec
- up to 0.6.0, new upstream

* Sat Nov 23 2013 Elan Ruusamäe <glen@delfi.ee> c81abe3
- fix package name

* Sat Nov 23 2013 Elan Ruusamäe <glen@delfi.ee> 26de232
- new, version 0.5.3

